#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityFishingCeleGiftLotteryMap.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityFishingCeleGiftLotteryMap> M_ActivityFishingCeleGiftLotteryMap::msSingleton(nullptr);

int M_ActivityFishingCeleGiftLotteryMap::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleGiftLotteryMapData* M_ActivityFishingCeleGiftLotteryMap::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityFishingCeleGiftLotteryMapData>& M_ActivityFishingCeleGiftLotteryMap::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleGiftLotteryMap::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityFishingCeleGiftLotteryMap::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleGiftLotteryMapData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mFreeWeight = element->IntAttribute("FreeWeight");
		data.mAdvWeight = element->IntAttribute("AdvWeight");
		data.mAdvNeedItem = element->IntAttribute("AdvNeedItem");
		data.mGiftId = element->IntAttribute("GiftId");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityFishingCeleGiftLotteryMap::Load()
{
	Load("../Config/M_ActivityFishingCeleGiftLotteryMap.xml");
}

M_ActivityFishingCeleGiftLotteryMap* M_ActivityFishingCeleGiftLotteryMap::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleGiftLotteryMap());
	}
	return msSingleton.get();
}
